import java.awt.Component;
import java.awt.event.MouseEvent;
import java.util.EventObject;
import javax.swing.AbstractCellEditor;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTable;
import javax.swing.SpinnerNumberModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

public class DonneesPanel extends JPanel {
    private JTable table;
    private DefaultTableModel model;
    private int amount;

    public DonneesPanel() {
        this.init();
    }

    private void init() {
        this.effacerDonnees();

        this.table = new JTable(this.model);
        this.add(new JScrollPane(this.table));
    }

    public void ajouterColonne() {
        if (this.amount < 5) {
            this.model.addColumn("Série " + this.amount++);

            TableColumnModel column = this.table.getColumnModel();
            TableColumn clm = column.getColumn(this.amount - 1);
            clm.setCellEditor(new SpinnerEditor());
        }

        System.out.println(this.amount);
    }

    public void supprimerColonne() {
        if (this.amount <= 1) {
            return;
        }

        removeColumn(this.amount--);

        System.out.println(this.amount);
    }

    public void effacerDonnees() {
        this.amount = 1;
        this.model = new DefaultTableModel(10, 0);

        this.model.addColumn("Données ");

        if (this.table != null) {
            this.table.setModel(this.model);
        }
    }

    private void removeColumn(int index) {
        int nRow = this.table.getRowCount();
        int nCol = this.table.getColumnCount() - 1;

        Object[][] cells = new Object[nRow][nCol];
        String[] names = new String[nCol];

        for (int j = 0; j < nCol; j++) {
            if (j < index) {
                names[j] = this.table.getColumnName(j);
                for (int i = 0; i < nRow; i++) {
                    cells[i][j] = this.table.getValueAt(i, j);
                }
            } else {
                names[j] = this.table.getColumnName(j + 1);
                for (int i = 0; i < nRow; i++) {
                    cells[i][j] = this.table.getValueAt(i, j + 1);
                }
            }
        }

        this.model = new DefaultTableModel(cells, names);
        this.table.setModel(this.model);
    }
}

class SpinnerEditor extends AbstractCellEditor implements TableCellEditor {
    final JSpinner spinner = new JSpinner();

    public SpinnerEditor() {
        spinner.setModel(new SpinnerNumberModel(0, 0, 500, 1));
    }

    public Component getTableCellEditorComponent(
            JTable table, Object value, boolean isSelected,
            int row, int column) {

        spinner.setValue(value);
        return spinner;
    }

    public boolean isCellEditable(EventObject evt) {
        if (evt instanceof MouseEvent) {
            return ((MouseEvent) evt).getClickCount() >= 2;
        }

        return true;
    }

    public Object getCellEditorValue() {
        return spinner.getValue();
    }
}